/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                       OS_186_c.c                         *
*               80186/80188 Specific Code                  *
*                  SMALL MEMORY MODEL                      *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk)[stksize];  /* decrement first ! 80186/80188 Small Model */
    *--stk   = (U16)FP_OFF(data);
    *--stk   = (U16)FP_SEG(task);
    *--stk   = (U16)FP_OFF(task);
    *--stk   = (U16)0x0200;                       /* PSW = Int. En.                       */
    *--stk   = (U16)FP_SEG(task);
    *--stk   = (U16)FP_OFF(task);
    *--stk   = (U16)0x0000;                       /* AX = 0                               */
    *--stk   = (U16)0x0000;                       /* CX = 0                               */
    *--stk   = (U16)0x0000;                       /* DX = 0                               */
    *--stk   = (U16)0x0000;                       /* BX = 0                               */
    *--stk   = (U16)0x0000;                       /* SP = 0                               */
    *--stk   = (U16)0x0000;                       /* BP = 0                               */
    *--stk   = (U16)0x0000;                       /* SI = 0                               */
    *--stk   = (U16)0x0000;                       /* DI = 0                               */
    *--stk   = (U16)0x0000;                       /* ES = 0                               */
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}
