/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                      OS_8051_c.c                         *
*                  8051 Specific Code                      *
*                  LARGE MEMORY MODEL                      *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk);
    *pstk    = (void *)&stk[stksize];          
#ifdef __C51__                                              /* KEIL C51 with Generic pointer        */
    *stk     = (U08)(task);                                 /* PCL                                  */
    *++stk   = (U08)((U16)task >>8 );                       /* PCH                                  */
    *++stk   = 0x00;                                        /* PSW                                  */
    *++stk   = 0x00;                                        /* ACC                                  */
    *++stk   = 0x00;                                        /* B                                    */
    *++stk   = 0x00;                                        /* R0                                   */
    *++stk   = (U08)(Tdata);                                /* R1 data LSB                          */
    *++stk   = (U08)((U16)Tdata >>8 );                      /* R2 data MSB                          */
    *++stk   = (U08)((U32)Tdata >>16 );                     /* R3 data G                            */
    *++stk   = 0x04;                                        /* R4                                   */
    *++stk   = 0x05;                                        /* R5                                   */
    *++stk   = 0x06;                                        /* R6                                   */
    *++stk   = 0x07;                                        /* R7                                   */
    *++stk   = 0x00;                                        /* DPH                                  */
    *++stk   = 0x00;                                        /* DPL                                  */
    *++stk   = (U08)(((U16)*pstk) >>8 );                    /* XSP area MSB                         */
    *++stk   = (U08)(*pstk);                                /* XSP area LSB                         */
    *++stk   = 18;                                          /* SP (bytes)                           */
#else
 #error This piece of code only tested with Keil C51
#endif
    // ---------------------
    // pstk was updated and is now the ascending end-of-stack
    return stk;
}
