
#define AUX_INT_VECT_BASE		(0x25)

.global _start
.section .vectors,text

.extern OSTick_ISR
.extern OSPendSV_ISR

reset:
;// handler's name              type      number  name                      offset in IVT (hex/dec)
.long   _start_v            ;   exception   0   program entry point       offset  0x0     0
.long   halt_handler        ;   exception   1   memory_error              offset  0x4     4
.long   halt_handler        ;   exception   2   instruction_error         offset  0x8     8
.long   halt_handler        ;   exception   3   EV_MachineCheck           offset  0xC     12
.long   halt_handler        ;   exception   4   EV_TLBMissI               offset  0x10    16
.long   halt_handler        ;   exception   5   EV_TLBMissD               offset  0x14    20
.long   halt_handler        ;   exception   6   EV_ProtV                  offset  0x18    24
.long   halt_handler        ;   exception   7   EV_PrivilegeV             offset  0x1C    28
.long   halt_handler        ;   exception   8   EV_SWI                    offset  0x20    32
.long   halt_handler        ;   exception   9   EV_Trap                   offset  0x24    36
.long   halt_handler        ;   exception   10  EV_Extension              offset  0x28    40
.long   halt_handler        ;   exception   11  EV_DivZero                offset  0x2C    44
.long   halt_handler        ;   exception   12  EV_DCError                offset  0x30    48
.long   halt_handler        ;   exception   13  EV_Maligned               offset  0x34    52
.long   halt_handler        ;   exception   14  unused                    offset  0x38    56
.long   halt_handler        ;   exception   15  unused                    offset  0x3C    60

.long   OSTick_ISR          ;   IRQ         16  core Timer 0              offset  0x40    64
.long   halt_handler        ;   IRQ         17  core Timer 1              offset  0x44    68
.long   OSPendSV_ISR        ;   IRQ         18                            offset  0x48    72
.long   halt_handler        ;   IRQ         19                            offset  0x4C    76
.long   halt_handler        ;   IRQ         20  sec Timer 0 (EMD7 + ESP)  offset  0x50    80
.long   halt_handler        ;   IRQ         21                            offset  0x54    84
.long   halt_handler        ;   IRQ         22  core DMA    (EMD7 + ESP)  offset  0x58    88
.long   halt_handler        ;   IRQ         23  core DMA    (EMD7 + ESP)  offset  0x5C    92
.long   halt_handler        ;   IRQ         24  GPIO                      offset  0x60    96
.long   halt_handler        ;   IRQ         25  I2C_0                     offset  0x64   100
.long   halt_handler        ;   IRQ         26  I2C_1                     offset  0x68   104
.long   halt_handler        ;   IRQ         27  SPI master                offset  0x6C   108
.long   halt_handler        ;   IRQ         28  SPI slave                 offset  0x70   112
.long   halt_handler        ;   IRQ         29  UART0                     offset  0x74   116
.long   halt_handler        ;   IRQ         30  UART1                     offset  0x78   120
.long   halt_handler        ;   IRQ         31  UART2                     offset  0x7C   124
.long   halt_handler        ;   IRQ         32  WDT                       offset  0x80   128
.long   halt_handler        ;   IRQ         33  Timer 0                   offset  0x84   132
.long   halt_handler        ;   IRQ         34  Timer 1                   offset  0x88   136
.long   halt_handler        ;   IRQ         35  reserved                  offset  0x8C   140
.long   halt_handler        ;   IRQ         36  reserved                  offset  0x90   144
.long   halt_handler        ;   IRQ         37  reserved                  offset  0x94   148

;; Use .rep directive for remaining interrupt vectors. Depending on the processor
;; configuration there may be up to 240 interrupts, starting at IRQ 16 (the lower
;; vector locations are for exceptions)

.rep	203
.long	halt_handler
.endr

.text

_start_v:
    mov r0, reset
    sr  r0, [AUX_INT_VECT_BASE]
    b _start

halt_handler:
    flag 1
    nop
    nop
    nop
    b halt_handler

