/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                     OS_MSP430_c.c                        *
*                TI MSP430 Specific Code                   *
*                       using IAR                          *
***********************************************************/
#include "../../../inc/pC_OS.h"
#include "../../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk)[stksize];          /* decrement first !                    */
    *--stk = (U16)task;
    *--stk = (U16)task;                                   /* Interrupt return pointer             */
    *--stk = (U16)0x0008;                                 /* Status register                      */
    *--stk = (U16)0x0404;
    *--stk = (U16)0x0505;
    *--stk = (U16)0x0606;
    *--stk = (U16)0x0707;
    *--stk = (U16)0x0808;
    *--stk = (U16)0x0909;
    *--stk = (U16)0x1010;
    *--stk = (U16)0x1111;
    *--stk = (U16)Tdata;                                  /* Pass 'Tdata' through register R12    */
    *--stk = (U16)0x1313;
    *--stk = (U16)0x1414;                         
    *--stk = (U16)0x1515;
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}
