/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                       OS_RL78_c.c                        *
*                Renesas RL78 Specific Code                *
*                                                          *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((U16 *)*pstk)[stksize];                  /* decrement first !                    */
#if __DATA_MODEL__ != __DATA_MODEL_NEAR__
 #error "none-NEAR not fully implemented & tested!"
    *--stk   = (U16)((U32)Tdata >> 16);                   /* parameter                            */
    *--stk   = (U16)Tdata;
    *--stk   = (U16)(((U32)task >> 16) & 0x000F) | 0x8600;/* PC bits 16-19 in lower 8 bits, psw in upper 16 bits      */
    *--stk   = (U16)task;                                 /* PC bits 0-15                         */
    *--stk   = (U16)0x1100;                               /* RP0                                  */
    *--stk   = (U16)0x3322;                               /* RP1                                  */
    *--stk   = (U16)0x5544;                               /* RP2                                  */
    *--stk   = (U16)0x7766;                               /* RP3                                  */ 
#else
    *--stk   = (U16)(((U32)task >> 16) & 0x000F) | 0x8600;/* PC bits 16-19 in lower 8 bits, psw in upper 16 bits      */
    *--stk   = (U16)task;                                 /* PC bits 0-15                         */
    *--stk   = (U16)Tdata;                                /* RP0 - parameter                      */
    *--stk   = (U16)0x3322;                               /* RP1                                  */
    *--stk   = (U16)0x5544;                               /* RP2                                  */
    *--stk   = (U16)0x7766;                               /* RP3                                  */ 
    *--stk   = (U16)0x0000;
#endif
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}

/**********************************************************/
 
#ifdef __IAR_SYSTEMS_ICC__                                // IAR compilers
 #if (__VER__ > 300)

  extern void OSCtxSw_ISR(void);
  extern void OSTick_ISR(void);

  #pragma vector = 0x38  //0x2C
  __interrupt void OStickvector(void)
  {
    OSTick_ISR();
  }

  #pragma vector = 0x7E
  __interrupt void OSshedvector(void)
  {
    OSCtxSw_ISR();
  }
 #endif 
#endif
 
/**********************************************************/
