/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                      OS_RX62N_c.c                        *
*              Renesas RX62N Specific Code                 *
*                                                          *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk)[stksize];          /* decrement first !                    */
    *--stk   = (OS_STK_TYPE)0x00030000L;                  /* PSW                                  */
    *--stk   = (OS_STK_TYPE)(task);                       /* PC : task start address              */
    *--stk   = (OS_STK_TYPE)0x15151515L;                  /* R15                                  */
    *--stk   = (OS_STK_TYPE)0x14141414L;                  /* R14                                  */
    *--stk   = (OS_STK_TYPE)0x13131313L;                  /* R13                                  */
    *--stk   = (OS_STK_TYPE)0x12121212L;                  /* R12                                  */
    *--stk   = (OS_STK_TYPE)0x11111111L;                  /* R11                                  */
    *--stk   = (OS_STK_TYPE)0x10101010L;                  /* R10                                  */
    *--stk   = (OS_STK_TYPE)0x09090909L;                  /* R9                                   */
    *--stk   = (OS_STK_TYPE)0x08080808L;                  /* R8                                   */
    *--stk   = (OS_STK_TYPE)0x07070707L;                  /* R7                                   */
    *--stk   = (OS_STK_TYPE)0x06060606L;                  /* R6                                   */
    *--stk   = (OS_STK_TYPE)0x05050505L;                  /* R5                                   */
    *--stk   = (OS_STK_TYPE)0x04040404L;                  /* R4                                   */
    *--stk   = (OS_STK_TYPE)0x03030303L;                  /* R3                                   */
    *--stk   = (OS_STK_TYPE)0x02020202L;                  /* R2                                   */
    *--stk   = (OS_STK_TYPE)Tdata;                        /* R1 : argument           (R0 is SP)   */
    *--stk   = (OS_STK_TYPE)0x00000100L;                  /* FPSW                                 */
    *--stk   = (OS_STK_TYPE)0x12345678L;                  /* Accumulator.                         */
    *--stk   = (OS_STK_TYPE)0x87654321L;                  /* Accumulator.                         */
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}
