/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                      OS_Rabbit_c.c                       *
*               Rabbit 2000/3000 Specific Code             *
*                    FAR MEMORY MODEL                      *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk)[stksize];          /* decrement first ! Rabbit 2000/3000 Model */
    *--stk           = (U16)Tdata;                        /* Simulate call to function            */
    stk              = (U16 *)(((U08 *) stk) - 1);
    * (U08 *) stk    = 0;                                 /* Place XPC of 0 on stack              */
    *--stk           = (U16)task;                         /* Put pointer to task on top of stack  */
    stk              = (U16 *)(((U08 *) stk) - 1);
    * (U08 *) stk    = 0;                                 /* Place IP of 0 on stack               */
    *--stk           = (U16)0xAAAA;                       /* AF  = 0xAAAA                         */
    *--stk           = (U16)0xBBBB;                       /* BC  = 0xBBBB                         */
    *--stk           = (U16)0xDDDD;                       /* DE  = 0xDDDD                         */
    *--stk           = (U16)0x1111;                       /* HL  = 0x1111                         */
    *--stk           = (U16)0xA0AA;                       /* AF' = 0xA0AA                         */
    *--stk           = (U16)0xBBB0;                       /* BC' = 0xBBB0                         */
    *--stk           = (U16)0xDDD0;                       /* DE' = 0xDDD0                         */
    *--stk           = (U16)0x1110;                       /* HL' = 0x1110                         */
    *--stk           = (U16)0xFFFF;                       /* IX  = 0xFFFF                         */
    *--stk           = (U16)0xEEEE;                       /* IY  = 0xEEEE                         */
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}
